local guildster, gTable = ...

function gTable.CreateGuildsterFrame(...)
    if not gTable.frameBG then
        gTable.frameBG = CreateFrame("Frame", "Guildster", UIParent, "BasicFrameTemplate")
        gTable.frameBG:SetPoint("CENTER", UIParent, "CENTER", 0, 80)
        gTable.frameBG:SetSize(750, 532)
        gTable.frameBG:SetScript("OnShow", populateFrame)
        gTable.frameBG:SetMovable(true)
        gTable.frameBG:EnableMouse(true)
        gTable.frameBG:RegisterForDrag("LeftButton")
        gTable.frameBG:SetScript("OnDragStart", gTable.frameBG.StartMoving)
        gTable.frameBG:SetScript("OnDragStop", gTable.frameBG.StopMovingOrSizing)
        gTable.frameBG:SetScript(
            "OnHide",
            function(self)
                gTable.sFrame:Hide()
            end
        )

        gTable.header = gTable.frameBG:CreateTexture(nil, "ARTWORK")
        gTable.header:SetPoint("TOPLEFT", gTable.frameBG, "TOPLEFT")
        gTable.header:SetSize(750, 20)

        gTable.header.title = gTable.frameBG:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gTable.header.title:SetText("Guildster")
        gTable.header.title:SetPoint("CENTER", gTable.header, "CENTER", 0, -1)

        local background = gTable.frameBG:CreateTexture(nil, "BACKGROUND")
        background:SetSize(512, 512)
        background:SetPoint("TOPLEFT", gTable.header, "BOTTOMLEFT", 2, 0)
        background:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground")

        local background2 = gTable.frameBG:CreateTexture(nil, "BACKGROUND")
        background2:SetSize(512, 512)
        background2:SetPoint("TOPRIGHT", gTable.header, "BOTTOMRIGHT", -2, 0)
        background2:SetTexture("Interface\\ACHIEVEMENTFRAME\\UI-GuildAchievement-AchievementBackground")
        background2:SetTexCoord(1, 0, 0, 1)

        local reqButton = CreateFrame("Button", "Guildster_Req_Button", gTable.frameBG, "UIPanelButtonTemplate")
        reqButton:SetText("Request Membership")
        reqButton:SetPoint("TOPRIGHT", gTable.frameBG, "BOTTOMRIGHT")
        reqButton:SetSize(150, 24)
        reqButton:SetEnabled(false)
        reqButton:SetScript(
            "OnLoad",
            function(self)
                if (IsInGuild()) then
                    reqButton:SetEnabled(false)
                end
            end
        )
        gTable.CreateFilterFrame(guildster, gTable)
        gTable.CreateScrollFrame(guildster, gTable)
    end
    gTable.frameBG:Show()
end

function gTable.CreateScrollFrame(guildster, gTable)
    local factionGroup = UnitFactionGroup("player")
    -- ScrollFrame
    gScrollFrame = CreateFrame("ScrollFrame", "Guildster_Content", gTable.frameBG, "FauxScrollFrameTemplate")
    gScrollFrame:SetFrameStrata("HIGH")
    gScrollFrame:SetPoint("TOPLEFT", gTable.filterFrame, "BOTTOMLEFT", 0, 0)
    gScrollFrame:SetPoint("BOTTOMRIGHT", -30, 8)
    gScrollFrame:SetScript(
        "OnVerticalScroll",
        function(self, offset)
            FauxScrollFrame_OnVerticalScroll(self, offset, gTable.buttonHeight, gTable.PopulateScrollFrame)
        end
    )

    gTable.buttonHeight = gScrollFrame:GetHeight() / gTable.numButtons

    gScrollFrame.buttons = {}
    for i = 1, gTable.numButtons do
        gScrollFrame.buttons[i] = CreateFrame("Button", "Guildster_Button" .. i, gScrollFrame)
        local gButton = gScrollFrame.buttons[i]
        gButton:SetSize(gScrollFrame:GetWidth(), gScrollFrame:GetHeight() / gTable.numButtons)
        gButton:SetPoint("TOPLEFT", 4, -(i - 1) * gScrollFrame:GetHeight() / gTable.numButtons - 8)
        gButton:RegisterForClicks("LeftButtonUp", "RightButtonUp")

        gButton.highlightTexture = gButton:CreateTexture(nil, "ARTWORK")
        gButton.highlightTexture:SetTexture("Interface\\Tooltips\\UI-Tooltip-Background")
        gButton.highlightTexture:SetColorTexture(1, 1, 0, 0.05)
        gButton.highlightTexture:SetPoint("TOPLEFT", gButton, "TOPLEFT", -3, 8)
        gButton.highlightTexture:SetSize(gButton:GetWidth() + 25, gButton:GetHeight())
        gButton.highlightTexture:Hide()

        gButton:SetScript(
            "OnEnter",
            function(self)
                gButton.highlightTexture:Show()
            end
        )
        gButton:SetScript(
            "OnLeave",
            function(self)
                gButton.highlightTexture:Hide()
            end
        )
        gButton:SetScript(
            "OnClick",
            function(self)
                gButton.highlightTexture:Hide()
            end
        )

        gButton.nameText = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormalHuge")
        gButton.nameText:SetPoint("TOP", gButton, "TOP", -60, 0)
        gButton.nameText:SetText(nil)

        gButton.membersIcon = gButton:CreateTexture(nil, "ARTWORK")
        gButton.membersIcon:SetSize(20, 20)
        gButton.membersIcon:SetPoint("TOPRIGHT", gButton.nameText, "TOPLEFT", -40, 0)
        gButton.membersIcon:SetTexture("Interface\\FriendsFrame\\UI-Toast-ChatInviteIcon")

        gButton.membersText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.membersText:SetPoint("LEFT", gButton.membersIcon, "RIGHT", 2, 0)
        gButton.membersText:SetText(nil)

        gButton.acvIcon = gButton:CreateTexture(nil, "ARTWORK")
        gButton.acvIcon:SetSize(20, 20)
        gButton.acvIcon:SetPoint("TOPLEFT", gButton.nameText, "TOPRIGHT", 30, 0)
        gButton.acvIcon:SetTexture("Interface\\AchievementFrame\\UI-Achievement-Guild")
        gButton.acvIcon:SetTexCoord(0.63281250, 0.67187500, 0.13085938, 0.16601563)

        gButton.acvText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.acvText:SetPoint("LEFT", gButton.acvIcon, "RIGHT", 2, 0)
        gButton.acvText:SetText(nil)

        gButton.commentText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.commentText:SetSize(300, 100)
        gButton.commentText:SetPoint("TOP", gButton.nameText, "BOTTOM", 0, 0)
        gButton.commentText:SetText(nil)

        -- Tabard Stuff
        gButton.tabardTopper = gButton:CreateTexture(nil, "ARTWORK", nil, 1)
        gButton.tabardTopper:SetPoint("TOPLEFT", gButton, "TOPLEFT", 10, 4)
        gButton.tabardTopper:SetSize(108.8, 27.2)
        gButton.tabardTopper:SetTexture("Interface\\AchievementFrame\\UI-Achievement-RightDDLInset")

        gButton.tabardEmblem = gButton:CreateTexture(nil, "ARTWORK", nil, 2)
        gButton.tabardEmblem:SetPoint("TOPLEFT", gButton.tabardTopper, "BOTTOMLEFT", 13, -2)
        gButton.tabardEmblem:SetSize(80, 90)
        if (factionGroup == "Alliance") then
            gButton.tabardEmblem:SetTexture("Interface\\FriendsFrame\\PlusManz-Alliance")
        else
            gButton.tabardEmblem:SetTexture("Interface\\FriendsFrame\\PlusManz-Horde")
        end

        gButton.tabard = gButton:CreateTexture(nil, "ARTWORK")
        gButton.tabard:SetPoint("TOPLEFT", gButton.tabardTopper, "BOTTOMLEFT", 9, 0)
        gButton.tabard:SetSize(88.5, 108)
        gButton.tabard:SetTexture("Interface\\GuildFrame\\GuildInspect-Parts")
        gButton.tabard:SetTexCoord(0.23632813, 0.46679688, 0.70117188, 0.98242188)

        gButton.border = gButton:CreateTexture(nil, "ARTWORK", nil, 3)
        gButton.border:SetPoint("TOPLEFT", gButton.tabardTopper, "BOTTOMLEFT", 9, 0)
        gButton.border:SetSize(88.5, 108)
        gButton.border:SetTexture("Interface\\GuildFrame\\GuildInspect-Parts")
        gButton.border:SetTexCoord(0.00195313, 0.23242188, 0.70117188, 0.98242188)

        gButton.dateText = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
        gButton.dateText:SetPoint("CENTER", gButton.tabardTopper, "CENTER", 0, 3)
        gButton.dateText:SetText(nil)

        -- Filter Checkbuttons
        -- Interests
        gButton.interests = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
        gButton.interests:SetPoint("TOPLEFT", gButton, "TOP", 150, 0)
        gButton.interests:SetText("Interests")

        gButton.intDiv = gButton:CreateTexture(nil, "ARTWORK")
        gButton.intDiv:SetPoint("TOPLEFT", gButton.interests, "BOTTOMLEFT", 0, 0)
        gButton.intDiv:SetWidth(200)
        gButton.intDiv:SetHeight(6)
        gButton.intDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
        gButton.intDiv:SetAlpha(0.3)

        gButton.Questing = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.Questing:SetPoint("TOPLEFT", gButton.interests, "BOTTOMLEFT", 18, -3)
        gButton.Questing:SetText("Questing")

        gButton.Dungeons = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.Dungeons:SetPoint("LEFT", gButton.Questing, "RIGHT", 60, 0)
        gButton.Dungeons:SetText("Dungeons")

        gButton.Raiding = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.Raiding:SetPoint("TOPLEFT", gButton.Questing, "BOTTOMLEFT", 0, -3)
        gButton.Raiding:SetText("Raids")

        gButton.PvP = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.PvP:SetPoint("TOPLEFT", gButton.Dungeons, "BOTTOMLEFT", 0, -3)
        gButton.PvP:SetText("PvP")

        gButton.RP = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.RP:SetPoint("TOPLEFT", gButton.Raiding, "BOTTOMLEFT", 0, -3)
        gButton.RP:SetText("Role Playing")

        -- Availability
        gButton.avail = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
        gButton.avail:SetPoint("TOPLEFT", gButton.RP, "BOTTOMLEFT", -20, -6)
        gButton.avail:SetText("Availability")

        gButton.availDiv = gButton:CreateTexture(nil, "ARTWORK")
        gButton.availDiv:SetPoint("TOPLEFT", gButton.avail, "BOTTOMLEFT", 0, 0)
        gButton.availDiv:SetWidth(200)
        gButton.availDiv:SetHeight(6)
        gButton.availDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
        gButton.availDiv:SetAlpha(0.3)

        gButton.Weekdays = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.Weekdays:SetPoint("TOPLEFT", gButton.avail, "BOTTOMLEFT", 18, -3)
        gButton.Weekdays:SetText("Weekdays")

        gButton.Weekends = gButton:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
        gButton.Weekends:SetPoint("LEFT", gButton.Weekdays, "RIGHT", 60, 0)
        gButton.Weekends:SetText("Weekends")

        -- Roles
        gButton.roles = gButton:CreateFontString(nil, "ARTWORK", "GameFontNormal")
        gButton.roles:SetPoint("TOPLEFT", gButton.Weekdays, "BOTTOMLEFT", -20, -6)
        gButton.roles:SetText("Roles")

        gButton.roleDiv = gButton:CreateTexture(nil, "ARTWORK")
        gButton.roleDiv:SetPoint("TOPLEFT", gButton.roles, "BOTTOMLEFT", 0, 0)
        gButton.roleDiv:SetWidth(200)
        gButton.roleDiv:SetHeight(6)
        gButton.roleDiv:SetTexture("Interface\\BankFrame\\HorizShadow")
        gButton.roleDiv:SetAlpha(0.3)

        gButton.Healer = gButton:CreateTexture(nil, "ARTWORK", nil, 5)
        gButton.Healer:SetPoint("TOP", gButton.roleDiv, "BOTTOM", 0, 2)
        gButton.Healer:SetSize(18, 18)
        gButton.Healer:SetTexture("Interface\\LFGFrame\\LFGRole")
        gButton.Healer:SetTexCoord(0.75, 1.0, 0, 1.0)
        gButton.Healer:Hide()

        gButton.Tank = gButton:CreateTexture(nil, "ARTWORK", nil, 5)
        gButton.Tank:SetPoint("RIGHT", gButton.Healer, "LEFT", -30, 0)
        gButton.Tank:SetSize(18, 18)
        gButton.Tank:SetTexture("Interface\\LFGFrame\\LFGRole")
        gButton.Tank:SetTexCoord(0.5, 0.75, 0, 1.0)
        gButton.Tank:Hide()

        gButton.Damage = gButton:CreateTexture(nil, "ARTWORK", nil, 5)
        gButton.Damage:SetPoint("LEFT", gButton.Healer, "RIGHT", 30, 0)
        gButton.Damage:SetSize(18, 18)
        gButton.Damage:SetTexture("Interface\\LFGFrame\\LFGRole")
        gButton.Damage:SetTexCoord(0.25, 0.5, 0, 1.0)
        gButton.Damage:Hide()

        gButton.divider = gButton:CreateTexture(nil, "ARTWORK")
        gButton.divider:SetPoint("BOTTOMLEFT", gButton, "BOTTOMLEFT", -2, 0)
        gButton.divider:SetWidth(gTable.frameBG:GetWidth() - 6)
        gButton.divider:SetHeight(9)
        gButton.divider:SetTexture("Interface\\BankFrame\\HorizShadow")
        gButton.divider:SetAlpha(0.3)
    end
end

SLASH_GUILDSTER1 = "/guildster"
SlashCmdList["GUILDSTER"] = function(msg)
    gTable.GetGuildInfo()
    gTable.CreateGuildsterFrame()
end
